% This file was created with JabRef 2.10.
% Encoding: ISO8859_1


@InBook{fankhauser:2009:softwaretechnik-security,
  title = {Softwaretechnik - Mit Fallbeispielen aus realen Entwicklungsprojekten},
  author = {Fankhauser, Florian and Schanes, Christian and Brem, Christian},
  chapter = {13},
  pages = {589--646},
  publisher = {Pearson Studium},
  year = {2009},

  address = {M{\"u}nchen},
  edition = {1},

  bibsource = {esse},
  url = {http://www.inso.tuwien.ac.at/publications/softwaretechnik/},
  urldate = {2017-01-16}
}

@Online{oasis:2010:homepage,
  title = {Organization for the advancement of structured information standards},
  author = {Oasis},
  url = {http://www.oasis-open.org},
  urldate = {2017-01-16},
  year = {2010}
}

@Article{schanes:2011:voip-fuzzer,
  title = {Security Test Approach for Automated Detection of Vulnerabilities of SIP-based VoIP Softphones},
  author = {Schanes, Christian and Taber, Stefan and Popp, Karin and Fankhauser, Florian and Grechenig, Thomas},
  journal = {International Journal On Advances in Security},
  year = {2011},

  month = sep,
  number = {1 and 2},
  pages = {95--105},
  volume = {4},

  abstract = {Voice over Internet Protocol based systems replace phone lines in many scenarios and are in wide use today. Automated security tests of such systems are required to detect implementation and configuration mistakes early and in an efficient way. In this paper we present a plugin for our fuzzer framework fuzzolution to automatically detect security vulnerabilities in Session Initiation Protocol based Voice over Internet Protocol softphones, which are examples for endpoints in such telephone systems. The presented approach automates the interaction with the Graphical User Interface of the softphones during test execution and also observes the behavior of the softphones using multiple metrics. Results of testing two open source softphones by using our fuzzer showed that various unknown vulnerabilities could be identified with the implemented plugin for our fuzzing framework.},
  bibsource = {esse},
  booktitle = {International Journal On Advances in Security, volume 4, numbers 1 and 2, 2011},
  keywords = {ESSE, Software testing; Computer network security; Graphical user interfaces; Internet telephony; Fuzzing},
  publisher = {IEEE Computer Society Press},
  url = {http://www.iariajournals.org/security/tocv4n12.html},
  urldate = {2017-01-16}
}

% ---------------------------------------------------------------------------------------------------------

@book{Murray2013,
abstract = {Predicting the binding mode of flexible polypeptides to proteins is an important task that falls outside the domain of applicability of most small molecule and protein−protein docking tools. Here, we test the small molecule flexible ligand docking program Glide on a set of 19 non-$\alpha$-helical peptides and systematically improve pose prediction accuracy by enhancing Glide sampling for flexible polypeptides. In addition, scoring of the poses was improved by post-processing with physics-based implicit solvent MM- GBSA calculations. Using the best RMSD among the top 10 scoring poses as a metric, the success rate (RMSD ≤ 2.0 {\AA} for the interface backbone atoms) increased from 21{\%} with default Glide SP settings to 58{\%} with the enhanced peptide sampling and scoring protocol in the case of redocking to the native protein structure. This approaches the accuracy of the recently developed Rosetta FlexPepDock method (63{\%} success for these 19 peptides) while being over 100 times faster. Cross-docking was performed for a subset of cases where an unbound receptor structure was available, and in that case, 40{\%} of peptides were docked successfully. We analyze the results and find that the optimized polypeptide protocol is most accurate for extended peptides of limited size and number of formal charges, defining a domain of applicability for this approach.},
archivePrefix = {arXiv},
arxivId = {arXiv:1011.1669v3},
author = {Murray, Scott},
booktitle = {Journal of Chemical Information and Modeling},
doi = {10.1017/CBO9781107415324.004},
eprint = {arXiv:1011.1669v3},
isbn = {9788578110796},
issn = {1098-6596},
keywords = {icle},
mendeley-groups = {Visualization},
number = {9},
pages = {1689--1699},
pmid = {25246403},
title = {{Interactive Data Visualization for the Web}},
volume = {53},
year = {2013}
}

@article{Almeida-Martinez2009,
abstract = {This article describes the educational tool VAST. We designed VAST to be used in compiler and language processing courses. The current version allows generating and visualizing syntax trees and their construction process. The main advantages of VAST follow: it is designed to be as independent from the parser generator as possible, it allows students to visualize the behavior of parsers they develop, and it has an interface designed to easily handle huge syntax trees. Finally, we describe two satisfactory preliminary evaluations from the usability and educational points of view.},
author = {Almeida-Martinez, F J and Urquiza-Fuentes, J and Velazquez-Iturbide, J a},
doi = {10.1109/ICALT.2009.158},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Almeida-Martinez, Urquiza-Fuentes, Velazquez-Iturbide - 2009 - Visualization of Syntax Trees for Language Processing Courses.pdf:pdf},
isbn = {0948-695X},
issn = {0958695X},
journal = {Journal of Universal Computer Science},
keywords = {1,2,3,4,category,d,educational software,k,syntax trees,visualization},
mendeley-groups = {Visualization},
number = {7},
pages = {1546--1561},
title = {{Visualization of Syntax Trees for Language Processing Courses}},
volume = {15},
year = {2009}
}

@phdthesis{Latorra2007,
author = {Latorra, Sage},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Latorra - 2007 - Visualization of Trees.pdf:pdf},
keywords = {trees,visualization},
mendeley-groups = {Visualization},
title = {{Visualization of Trees}},
year = {2007}
}

@inproceedings{Nguyen2003SOTree,
abstract = {This paper describes some improvements over the original Space-Optimized Tree technique for the visualization and manipulation of very large hierarchies. The new system uses an improved algorithm to calculate geometrical layouts and it also provides better navigation capability. We introduce our new layout algorithm that can make more consistence of the display than the original layout technique made. We also combine DualView (a new focus+context technique) with the current modified semantic zooming in order to interactively navigate through the large and very large hierarchies.},
author = {Nguyen, Quang Vinh and Huang, Mao Lin},
booktitle = {Pan-Sydney Area Workshop on Visual Information Processing (VIP2002)},
isbn = {1920682015},
mendeley-groups = {Visualization},
title = {{Improvements of Space-Optimized Tree for Visualizing and Manipulating Very Large Hierarchies}},
year = {2003}
}

@article{Munzner2003a,
abstract = {Structural comparison of large trees is a difficult task that is only partially supported by current visualization techniques, which are mainly designed for browsing. We present TreeJuxtaposer, a system designed to support the comparison task for large trees of several hundred thousand nodes. We introduce the idea of "guaranteed visibility", where highlighted areas are treated as landmarks that must remain visually apparent at all times. We propose a new methodology for detailed structural comparison between two trees and provide a new nearly-linear algorithm for computing the best corresponding node from one tree to another. In addition, we present a new rectilinear Focus+Context technique for navigation that is well suited to the dynamic linking of side-by-side views while guaranteeing landmark visibility and constant frame rates. These three contributions result in a system delivering a fluid exploration experience that scales both in the size of the dataset and the number of pixels in the display. We have based the design decisions for our system on the needs of a target audience of biologists who must understand the structural details of many phylogenetic, or evolutionary, trees. Our tool is also useful in many other application domains where tree comparison is needed, ranging from network management to call graph optimization to genealogy.},
author = {Munzner, Tamara and Guimbreti{\`{e}}re, Fran{\c{c}}ois and Tasiran, Serdar and Zhang, Li and Zhou, Yunhong},
doi = {10.1145/1201775.882291},
file = {:home/kroissma/Downloads/TreeJuxtaposer{\_}Scalable{\_}Tree{\_}Comparison{\_}Using{\_}Focu.pdf:pdf},
isbn = {1581137095},
issn = {07300301},
journal = {ACM SIGGRAPH 2003 Papers on - SIGGRAPH '03},
mendeley-groups = {Visualization},
number = {July 2003},
pages = {453},
title = {{TreeJuxtaposer}},
url = {http://portal.acm.org/citation.cfm?doid=1201775.882291},
year = {2003}
}


@article{Budiu2006,
abstract = {We present an experiment that compares how people perform search tasks$\backslash$nin a degree-of-interest browser and in a Windows-Explorer-like browser.$\backslash$nOur results show that, whereas users do attend to more information$\backslash$nin the DOI browser, they do not complete the task faster than in$\backslash$nan Explorer-like browser. However, in both types of browser, users$\backslash$nare faster to complete high information scent search tasks than low$\backslash$ninformation scent tasks. We present an ACT-R computational model$\backslash$nof the search task in the DOI browser. The model describes how a$\backslash$nvisual search strategy may combine with semantic aspects of processing,$\backslash$nas captured by information scent. We also describe a way of automatically$\backslash$nestimating information scent in an ontological hierarchy by querying$\backslash$na large corpus (in our case, Google's corpus).},
author = {Budiu, Raluca and Pirolli, Peter and Fleetwood, Michael},
doi = {10.1145/1133265.1133358},
isbn = {1595933530},
journal = {Advanced visual interfaces - AVI '06},
mendeley-groups = {Visualization},
pages = {457--462},
title = {{Navigation in degree of interest trees}},
url = {http://portal.acm.org/citation.cfm?doid=1133265.1133358},
year = {2006}
}

@article{Martinez2014,
abstract = {At the heart of software evolution is a sequence of edit actions, called an edit script, made to a source code file. Since software systems are stored version by version, the edit script has to be computed from these versions, which is known as a complex task. Existing approaches usually compute edit scripts at the text granularity with only add line and delete line actions. However, inferring syntactic changes from such an edit script is hard. Since moving code is a frequent action performed when editing code, it should also be taken into account. In this paper, we tackle these issues by introducing an algorithm computing edit scripts at the abstract syntax tree granularity including move actions. Our objective is to compute edit scripts that are short and close to the original developer intent. Our algorithm is implemented in a freely-available and extensible tool that has been intensively validated.},
author = {{Matias Martinez}, Martin Jean-R{\'{e}}my Falleri Flor{\'{e}}al Morandat Xavier Blanc and Monperrus},
doi = {10.1145/2642937.2642982},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Jean-R{\'{e}}my Falleri, Flor{\'{e}}al Morandat, Xavier Blanc, Matias Martinez, Monperrus - 2014 - Fine-grained and Accurate Source Code Diﬀeren.pdf:pdf},
isbn = {9781450330138},
journal = {Proceedings of the 29th ACM/IEEE international conference on Automated software engineering - ASE '14},
keywords = {()},
mendeley-groups = {Source{\_}Code{\_}Evolution},
pages = {313--324},
title = {{Fine-grained and accurate source code differencing}},
url = {http://dl.acm.org/citation.cfm?doid=2642937.2642982},
year = {2014}
}

@article{Cui2010,
abstract = {The code comparison technology plays a very important part in the work of plagiarism detection and software evaluation. Software plagiarism mainly appears as copy-and-paste or with a little modification after this, which will not change the function of the code, such as replacing the name of methods or variables, reordering the sequence of the statements etc. This paper introduces a plagiarism detection tool named CCS (Code Comparison System) which is based on the Abstract Syntax Tree (AST). According to the syntax tree's characteristics, CCS calculates their hash values, transforms their storage forms, and then compares them node by node. As a result, the efficiency improves. Moreover, CCS preprocesses a large amount of source code in its database for potential use, which also accelerate the course of plagiarism detection. CCS also takes special measurement to reduce mistakes when calculating the hash values of the operations like subtraction and division. It performs well in the code comparison field, and is able to help with the copyright protecting of the source code.},
author = {Cui, Baojiang and Li, Jiansong and Guo, Tao and Wang, Jianxin and Ma, Ding},
doi = {10.1109/ICBNMT.2010.5705174},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Cui et al. - 2010 - Code Comparison System based on Abstract Syntax Tree(2).pdf:pdf},
isbn = {9781424467709},
journal = {Proceedings - 2010 3rd IEEE International Conference on Broadband Network and Multimedia Technology, IC-BNMT2010},
keywords = {CCS,Code comparison,Code plagiarism,Hash value,Syntax tree},
mendeley-groups = {Source{\_}Code{\_}Evolution},
pages = {668--673},
title = {{Code Comparison System based on Abstract Syntax Tree}},
year = {2010}
}

@article{Telea2008,
abstract = {Understanding detailed changes done to source code is of great importance in software maintenance. We present Code Flows, a method to visualize the evolution of source code geared to the understanding of fine and mid-level scale changes across several file versions. We enhance an existing visual metaphor to depict software structure changes with techniques that emphasize both following unchanged code as well as detecting and highlighting important events such as code drift, splits, merges, insertions and deletions. The method is illustrated with the analysis of a real-world C++ code system.},
author = {Telea, Alexandru and Auber, David},
doi = {10.1111/j.1467-8659.2008.01214.x},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Telea, Auber - 2008 - Code flows Visualizing structural evolution of source code.pdf:pdf},
isbn = {0167-7055},
issn = {14678659},
journal = {Computer Graphics Forum},
mendeley-groups = {Visualization},
number = {3},
pages = {831--838},
title = {{Code flows: Visualizing structural evolution of source code}},
volume = {27},
year = {2008}
}

@article{Chevalier2007a,
abstract = {We present a method to detect and visualize evolution patterns in C++ source code. Our method consists of three steps. First, we extract an annotated syntax tree (AST) from each version of a given C++ source code. Next, we hash the extracted syntax nodes based on a metric combining structure and type information, and construct matches (correspondences) between similar-hash subtrees. Our technique detects code fragments which have not changed, or changed little, during the software evolution. By parameterizing the similarity metric, we can flexibly decide what is considered to be identical or not during the software evolution. Finally, we visualize the evolution of the code structure by emphasizing both changing and constant code patterns. We demonstrate our technique on a versioned code base containing a variety of changes ranging from simple to complex. Copyright 2007 ACM.},
author = {Chevalier, F and Auber, D and Telea, A},
doi = {10.1145/1294948.1294971},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Chevalier, Auber, Telea - 2007 - Structural analysis and visualization of C code evolution using syntax trees.pdf:pdf},
isbn = {9781595937223 (ISBN)},
journal = {IWPSE'07: Ninth International Workshop on Principles of Software Evolution - In conjunction with the 6th ESEC(European Software Engineering Conference)/FSE(Foundations of Software Engineering) Joint Meeting},
keywords = {Annotated syntax tree (AST),Code structure evolution,Codes (symbols),Computer programming languages,Software engineering,Software visualization,Syntactics,Syntax trees,Trees (mathematics)},
mendeley-groups = {Visualization},
pages = {90--97},
title = {{Structural analysis and visualization of C++ code evolution using syntax trees}},
year = {2007}
}

@article{Voinea2005,
abstract = {During the life cycle of a software system, the source code is changed many times. We study how developers can be enabled to get insight in these changes, in order to understand the status, history and structure better, as well as for instance the roles played by various contributors. We present CVSscan, an integrated multiview environment for this. Central is a line-oriented display of the changing code, where each version is represented by a column, and where the horizontal direction is used for time, Separate linked displays show various metrics, as well as the source code itself. A large variety of options is provided to visualize a number of different aspects. Informal user studies demonstrate the efficiency of this approach for real world use cases.},
author = {Voinea, Lucian and Telea, Alex and van Wijk, Jarke J},
doi = {http://dx.doi.org/10.1145/1056018.1056025},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Voinea, Telea, van Wijk - 2005 - CVSscan visualization of code evolution.pdf:pdf},
isbn = {1595930736},
journal = {Proceedings of the 2005 ACM symposium on Software visualization},
keywords = {software evolution,software visualization},
mendeley-groups = {Visualization},
number = {212},
pages = {47--56},
title = {{CVSscan: visualization of code evolution}},
url = {http://doi.acm.org/10.1145/1056018.1056025},
volume = {1},
year = {2005}
}

@article{Myers1986,
abstract = {The problems of finding a longest common subsequence of two sequencesA andB and a shortest edit script for transformingA intoB have long been known to be dual problems. In this paper, they are shown to be equivalent to finding a shortest/longest path in an edit graph. Using this perspective, a simpleO(ND) time and space algorithm is developed whereN is the sum of the lengths ofA andB andD is the size of the minimum edit script forA andB. The algorithm performs well when differences are small (sequences are similar) and is consequently fast in typical applications. The algorithm is shown to haveO(N+D 2) expected-time performance under a basic stochastic model. A refinement of the algorithm requires onlyO(N) space, and the use of suffix trees leads to anO(N logN+D 2) time variation.},
author = {Myers, Eugene W.},
doi = {10.1007/BF01840446},
isbn = {0178461714320541},
issn = {01784617},
journal = {Algorithmica},
keywords = {Edit graph,File comparison,Longest common subsequence,Shortest edit script},
mendeley-groups = {Source{\_}Code{\_}Evolution},
pages = {251--266},
title = {{An O(ND) difference algorithm and its variations}},
year = {1986}
}

@article{Apiwattanapong2007,
abstract = {During software evolution, information about changes between different versions of a program is useful for a number of software engineering tasks. For example, configuration-management systems can use change information to assess possible conflicts among updates from different users. For another example, in regression testing, knowledge about which parts of a program are unchanged can help in identifying test cases that need not be rerun. For many of these tasks, a purely syntactic differencing may not provide enough information for the task to be performed effectively. This problem is especially relevant in the case of object-oriented software, for which a syntactic change can have subtle and unforeseen effects. In this paper, we present a technique for comparing object-oriented programs that identifies both differences and correspondences between two versions of a program. The technique is based on a representation that handles object-oriented features and, thus, can capture the behavior of object-oriented programs. We also present JDiff, a tool that implements the technique for Java programs. Finally, we present the results of four empirical studies, performed on many versions of two medium-sized subjects, that show the efficiency and effectiveness of the technique when used on real programs.},
author = {Apiwattanapong, Taweesup and Orso, Alessandro and Harrold, Mary Jean},
doi = {10.1007/s10515-006-0002-0},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Apiwattanapong, Orso, Harrold - 2007 - JDiff A differencing technique and tool for object-oriented programs(2).pdf:pdf},
issn = {09288910},
journal = {Automated Software Engineering},
keywords = {Program differencing,Software evolution},
mendeley-groups = {Source{\_}Code{\_}Evolution},
number = {1},
pages = {3--36},
title = {{JDiff: A differencing technique and tool for object-oriented programs}},
volume = {14},
year = {2007}
}

@article{Neamtiu2005,
abstract = {Mining software repositories at the source code level can provide a greater understanding of how software evolves. We present a tool for quickly comparing the source code of different versions of a C program. The approach is based on partial abstract syntax tree matching, and can track simple changes to global variables, types and functions. These changes can characterize aspects of software evolution useful for answering higher level questions. In particular, we consider how they could be used to inform the design of a dynamic software updating system. We report results based on measurements of various versions of popular open source programs, including BIND, OpenSSH, Apache, Vsftpd and the Linux kernel.},
author = {Neamtiu, Iulian and Foster, Jeffrey S. and Hicks, Michael},
doi = {10.1145/1082983.1083143},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Neamtiu, Foster, Hicks - 2005 - Understanding source code evolution using abstract syntax tree matching.pdf:pdf},
isbn = {1595931236},
issn = {01635948},
journal = {ACM SIGSOFT Software Engineering Notes},
keywords = {abstract syntax trees,software evolu-,source code analysis},
mendeley-groups = {Source{\_}Code{\_}Evolution},
number = {4},
pages = {1},
title = {{Understanding source code evolution using abstract syntax tree matching}},
url = {http://portal.acm.org/citation.cfm?doid=1082983.1083143},
volume = {30},
year = {2005}
}

@article{Hunt1976,
abstract = {The program diff reports differences between two files, expressed as a minimal list of line changes to bring either file into agreement with the other. Diff has been engineered to make efficient use of time and space on typical inputs that arise in vetting version-to-version changes in computer-maintained or computer-generated documents. Time and space usage are observed to vary about as the sum of the file lengths on real data, although they are known to vary as the product of the file lengths in the worst case. The central algorithm of diff solves the 'longest common subsequence problem' to find the lines that do not change between files. Practical efficiency is gained by attending only to certain critical 'candidate' matches between the files, the breaking of which would shorten the longest subsequence common to some pair of initial segments of the two files. Various techniques of hashing, presorting into equivalence classes, merging by binary search, and dynamic storage allocation are used to obtain good performance.},
author = {Hunt, J W and Mcilroy, M D},
file = {:home/kroissma/.local/share/data/Mendeley Ltd./Mendeley Desktop/Downloaded/Hunt, Mcilroy - 1976 - An Algorithm for Differential File Comparison.pdf:pdf},
journal = {Time},
mendeley-groups = {Source{\_}Code{\_}Evolution},
number = {41},
pages = {1--9},
title = {{An Algorithm for Differential File Comparison}},
url = {https://www.cs.dartmouth.edu/{~}doug/diff.pdf},
volume = {41},
year = {1976}
}

@phdthesis{Grossauer2018,
author = {Grossauer, Stefan},
title = {{Programming Language Independent Source Code Evolution Analysis Using Abstract Syntax Trees - Backend: Abstract Syntax Tree Generation}},
year = {2018}
}